Wt: Wt::WVirtualImage Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
Wt::WVirtualImage Class Reference

An abstract widget that shows a viewport to a virtually large image. More...

`#include <Wt/WVirtualImage.h>`

Inheritance diagram for Wt::WVirtualImage:
[legend]

## Public Member Functions
| WVirtualImage (int viewPortWidth, int viewPortHeight, ::int64_t imageWidth, ::int64_t imageHeight, int gridImageSize=256)
| Creates a viewport for a virtual image.
| ~WVirtualImage ()
| Destructor.
void | redrawAll ()
| Regenerates and redraws the image pieces.
void | enableDragging ()
| Enables mouse dragging to scroll around the image.
void | scroll (::int64_t dx, ::int64_t dy)
| Scrolls the viewport of the image over a distance.
void | scrollTo (::int64_t x, ::int64_t y)
| Scrolls the viewport of the image to a specific coordinate.
::int64_t | imageWidth () const
| Returns the virtual image width.
::int64_t | imageHeight () const
| Returns the virtual image height.
void | resizeImage (::int64_t w, ::int64_t h)
| Resizes the virtual image.
int | viewPortWidth () const
| Returns the viewport width.
int | viewPortHeight () const
| Returns the viewport height.
int | gridImageSize () const
| Returns the size of a single piece.
::int64_t | currentTopLeftX () const
| Returns the current top left X coordinate.
::int64_t | currentTopLeftY () const
| Returns the current top left Y coordinate.
::int64_t | currentBottomRightX () const
| Returns the current bottom right X coordinate.
::int64_t | currentBottomRightY () const
| Returns the current bottom right Y coordinate.
Signal< ::int64_t, ::int64_t > & | viewPortChanged ()
| Signal emitted whenever the viewport changes.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Static Public Attributes
static const ::int64_t | Infinite
| Special value for imageWidth or imageHeight.
Static Public Attributes inherited from Wt::WWidget

## Protected Member Functions
virtual std::unique_ptr< WImage > | createImage (::int64_t x, ::int64_t y, int width, int height)
| Creates a grid image for the given rectangle.
virtual std::unique_ptr< WResource > | render (::int64_t x, ::int64_t y, int width, int height)
| Render a grid image for the given rectangle.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

An abstract widget that shows a viewport to a virtually large image.

WVirtualImage is an abstract class which renders a large image in small pieces. The large image is broken down, and rendered as a grid of smaller square images parts.

The WVirtualImage may provide interactive navigation using the mouse, by reacting to dragging of the mouse on the image.

The WVirtualImage renders pieces in and bordering the current viewport. In this way, provided the individual pieces load sufficiently fast, the user has effectively the impression of scrolling through a single large image, without glitches. Whenever the image is navigated, if necessary, new images are rendered to maintain the border. Images that are too far from the current viewport are pruned away, so that browser memory remains bounded.

To use this class, you must reimplement one of two virtual methods to specify the contents of each grid piece. Either you provide a suitable WImage for every grid piece, or you provide a WResource which renders the contents for a WImage for every grid piece.

The total image dimensions are (0, 0) to (imageWidth, imageHeight) for a finite image, and become unbounded (including negative numbers) for each dimension which is Infinite.

### CSS

Styling through CSS is not applicable.

## Constructor & Destructor Documentation

## ◆ WVirtualImage()

Wt::WVirtualImage::WVirtualImage | ( | int | viewPortWidth,
|  | int | viewPortHeight,
|  | ::int64_t | imageWidth,
|  | ::int64_t | imageHeight,
|  | int | gridImageSize = 256 )

Creates a viewport for a virtual image.

You must specify the size of the viewport, and the size of the virtual image. The latter dimensions may be the special value Infinite, indicating that in one or more dimensions, the image size is infinite (in practice limited by the maximum integer value).

In addition, you must specify the size of each square grid item. The default is 256 by 256.

## Member Function Documentation

## ◆ createImage()

virtual std::unique_ptr< WImage > Wt::WVirtualImage::createImage | ( | ::int64_t | x,
|  | ::int64_t | y,
|  | int | width,
|  | int | height )
| protectedvirtual

Creates a grid image for the given rectangle.

Create the image which spans image coordinates with left upper corner (x, y) and given width and height.

Width and height will not necesarilly equal gridImageSize(), if the the image is not infinite sized.

The default implementation calls render() and creates an image for the resource returned.

You should override this method if you wish to serve for example static image content.

See also
  render()

## ◆ currentBottomRightX()

::int64_t Wt::WVirtualImage::currentBottomRightX | ( |  | ) | const

Returns the current bottom right X coordinate.

See also
  currentBottomRightY()

## ◆ currentBottomRightY()

::int64_t Wt::WVirtualImage::currentBottomRightY | ( |  | ) | const

Returns the current bottom right Y coordinate.

See also
  currentBottomRightX()

## ◆ currentTopLeftX()

::int64_t Wt::WVirtualImage::currentTopLeftX | ( |  | ) | const

Returns the current top left X coordinate.

See also
  currentTopLeftY()

## ◆ currentTopLeftY()

::int64_t Wt::WVirtualImage::currentTopLeftY | ( |  | ) | const

Returns the current top left Y coordinate.

See also
  currentTopLeftX()

## ◆ enableDragging()

void Wt::WVirtualImage::enableDragging | ( |  | ) |

Enables mouse dragging to scroll around the image.

The cursor is changed to a 'move' symbol to indicate the interactivity.

## ◆ gridImageSize()

int Wt::WVirtualImage::gridImageSize | ( |  | ) | const

Returns the size of a single piece.

This is the size of a side of the square pieces that is used to render the visible part of the image.

## ◆ imageHeight()

::int64_t Wt::WVirtualImage::imageHeight | ( |  | ) | const

Returns the virtual image height.

See also
  imageWidth(), resizeImage()

## ◆ imageWidth()

::int64_t Wt::WVirtualImage::imageWidth | ( |  | ) | const

Returns the virtual image width.

See also
  imageHeight(), resizeImage()

## ◆ redrawAll()

void Wt::WVirtualImage::redrawAll | ( |  | ) |

Regenerates and redraws the image pieces.

This method invalidates all current grid images, and recreates them.

## ◆ render() [1/2]

virtual std::unique_ptr< WResource > Wt::WVirtualImage::render | ( | ::int64_t | x,
|  | ::int64_t | y,
|  | int | width,
|  | int | height )
| protectedvirtual

Render a grid image for the given rectangle.

Returns a resource that streams an image which renders the rectangle which spans image coordinates with left upper corner (x, y) and given width and height.

Width and height will not necesarilly equal to gridImageSize(), if the the image is not infinite sized.

The default implementation throws an Exception. You must reimplement this method unless you reimplement createImage().

See also
  createImage()

## ◆ render() [2/2]

virtual void Wt::WCompositeWidget::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

## ◆ resizeImage()

void Wt::WVirtualImage::resizeImage | ( | ::int64_t | w,
|  | ::int64_t | h )

Resizes the virtual image.

This sets a new virtual size for the image. The viewport size sets the visible portion of the image.

See also
  imageWidth(), imageHeight()

## ◆ scroll()

void Wt::WVirtualImage::scroll | ( | ::int64_t | dx,
|  | ::int64_t | dy )

Scrolls the viewport of the image over a distance.

See also
  scrollTo()

## ◆ scrollTo()

void Wt::WVirtualImage::scrollTo | ( | ::int64_t | x,
|  | ::int64_t | y )

Scrolls the viewport of the image to a specific coordinate.

Scroll the viewport so that its top left coordinate becomes (x, y).

See also
  scroll()

## ◆ viewPortChanged()

Signal< ::int64_t, ::int64_t > & Wt::WVirtualImage::viewPortChanged | ( |  | ) |

Signal emitted whenever the viewport changes.

The viewport can be changed by the user dragging the image or through the API methods scrollTo() and scroll().

## ◆ viewPortHeight()

int Wt::WVirtualImage::viewPortHeight | ( |  | ) | const

Returns the viewport height.

See also
  viewPortWidth()

## ◆ viewPortWidth()

int Wt::WVirtualImage::viewPortWidth | ( |  | ) | const

Returns the viewport width.

See also
  viewPortHeight()